package cz.muni.fi.pa165.core.manufacturer;

import cz.muni.fi.pa165.core.common.DomainObject;
import cz.muni.fi.pa165.core.device.Device;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;

@Getter
@Setter
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "domain_manufacturer")
public class Manufacturer extends DomainObject {

  @Column(unique = true, nullable = false)
  private String name;

  @OneToMany(mappedBy = "manufacturer")
  private List<Device> deviceList;
}
