package cz.muni.fi.pa165.core.user;

import cz.muni.fi.pa165.core.device.Device;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Optional;

@Repository
public interface UserRepository extends JpaRepository<User, String> {
	@Modifying
	@Query("UPDATE User u set u.username= :#{#user.username}, u.password= :#{#user.password}, u.lastName= :#{#user.lastName}, u.firstName= :#{#user.firstName}, u.email= :#{#user.email} where u.id = :#{#id}")
	int update(@Param("user") User user, @Param("id") String id);


	@Query("Select SUM(m.consumptionKWH) " +
			"From User u " +
			"INNER JOIN HouseRole hr " +
			"INNER JOIN House h " +
			"INNER JOIN SmartMeter s " +
			"INNER JOIN Metrics m " +
			"where u.id = :#{#userId} and h.id = :#{#houseId} and m.timeStamp >= :#{#startTime} and m.timeStamp <= :#{#endTime}")
	Double getStatisticsData(@Param("userId") String userId,
							 @Param("houseId") String houseId,
							 @Param("startTime") LocalDateTime startTime,
							 @Param("endTime") LocalDateTime endTime);
}
